import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.lang.Thread;
import java.lang.Runnable;
import java.awt.event.ActionListener;

public class ChatClient extends JFrame implements Client
{
					String nick = "^.^!";
					String chatName = "dummy";
					String id = "000000";
					String host = "^.^!";
//					JLabel buddyListLabel = new JLabel(" ģ");

					JLabel roomLabel = new JLabel(" :");
					JLabel roomTitleLabel = new JLabel(" "+"-    -");
//					JLabel messageLabel = new JLabel("[    ]");

					JButton buddyListButton = new JButton(" ģ");
					BuddyList buddyList = new BuddyList();
					JButton memoButton = new JButton("[ ]");					

					TextArea messageArea = new TextArea();
					JTextField messageField = new JTextField(30);
					
					ChatMsg chatMsg;
					Color wColor = Color.blue;
					Color bwColor = Color.white;
					Font wFont = new Font("SansSerif",Font.PLAIN,12) ;
					ImageIcon wImageIcon = new ImageIcon("images/sound.gif");
//					JLabel chatLabel;
					String chatWord = "^.^";
					int wSize = 12;				
					String ENDMARK = "\n";									
					JButton liButton = new JButton("<α>");
					JButton rtButton = new JButton("");
					JButton rmButton = new JButton("游");
					JButton ncButton = new JButton("̸");
					JButton biButton = new JButton("ģʴ");
					JButton brButton = new JButton("ģ");
					JButton bgButton = new JButton("׷");
					JButton bdButton = new JButton("");
					JButton hbButton = new JButton("ȣ");
//					JButton biButton = new JButton("ȣ׷");
					JButton coButton = new JButton("ۻ");
					JButton foButton = new JButton("۲ú");
					JButton msButton = new JButton("޸");
					JButton mrButton = new JButton("޸");
					JButton ftButton = new JButton("ȭ");
					
					JButton loButton = new JButton("α׾ƿ");
					JButton blankButton = new JButton("                ");
					
					JPanel messagePanel = new JPanel(new BorderLayout()); 
					JPanel buddyPanel = new JPanel(new BorderLayout()); 
					JPanel buttonPanel = new JPanel(new GridLayout(13,1));
					JPanel titlePanel = new JPanel(new BorderLayout());
					JPanel roomPanel = new JPanel();		
					ScrollPane messagePane = new ScrollPane(ScrollPane.SCROLLBARS_NEVER);

					OutputStream os;// ȭ   ¸  
					InputStream is;// ȭ  ޱ 
					ObjectInputStream ois;// ȭ    ޱ 
					ObjectOutputStream oos;//ȭ Ż¸  
					Socket toServer;
					Socket fromServer;
					String serverURL;

					static int FILE_PORT;
					static int QUE_LENGTH;
					static int PORT;
					Datum datum;
					Memorandum memo;
					Memorandum[] memoA;
					MemoPersistent memoPersistent;
					InitProperty initProperty;
					
	public ChatClient(String title)
	{
		super(title);
		initProperty = new InitProperty();
		init();
		new ChatInfoFrame(this,"<α>");
		
		PORT = Integer.parseInt(initProperty.getValue("PORT"));
		serverURL = initProperty.getValue("serverURL");
		FILE_PORT = Integer.parseInt(initProperty.getValue("FILE_PORT"));
		QUE_LENGTH = Integer.parseInt(initProperty.getValue("QUE_LENGTH"));
		PORT = Integer.parseInt(initProperty.getValue("PORT"));
		new SMFileServer(FILE_PORT,QUE_LENGTH);
		System.out.println("ȭ  Ͽϴ.");
//		connect();	
	}
	
	public static void main(String atgs[])
	{
		String title = "     SAYTO HAPPY MESSANGER" ;
		ChatClient chatClient = new ChatClient(title);
		chatClient.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	void init()
	{
		int FRED = Integer.parseInt(initProperty.getValue("FORE_RED"));
		int FGREEN = Integer.parseInt(initProperty.getValue("FORE_GREEN"));
		int FBLUE = Integer.parseInt(initProperty.getValue("FORE_BLUE"));
		wColor = new Color(FRED,FGREEN,FBLUE);

		int BRED = Integer.parseInt(initProperty.getValue("BACK_RED"));
		int BGREEN = Integer.parseInt(initProperty.getValue("BACK_GREEN"));
		int BBLUE = Integer.parseInt(initProperty.getValue("BACK_BLUE"));
		bwColor = new Color(BRED,BGREEN,BBLUE);

		String FONT_STRING = initProperty.getValue("FONT_STRING");
		int FONT_SIZE = Integer.parseInt(initProperty.getValue("FONT_SIZE"));
		int FONT_STYLE = Integer.parseInt(initProperty.getValue("FONT_STYLE"));

		Font messageFont = new Font(FONT_STRING,FONT_SIZE,FONT_STYLE);

		messageArea.setFont(messageFont);

		messageArea.setEditable(false);
		Container c = getContentPane();
		c.setLayout(new BorderLayout());

		c.add(buddyPanel,BorderLayout.WEST);////////////////////
		c.add(messagePane,BorderLayout.CENTER);
		messagePane.add(messageArea);

		c.add(buttonPanel,BorderLayout.EAST);
		c.add(messagePanel,BorderLayout.SOUTH);
		c.add(titlePanel,BorderLayout.NORTH);
		
		buddyPanel.add(buddyListButton,BorderLayout.NORTH);////////////////////
		buddyPanel.add(buddyList,BorderLayout.CENTER);////////////////////
		titlePanel.add(roomPanel,BorderLayout.CENTER);
		roomPanel.add(roomLabel);
		roomPanel.add(roomTitleLabel);
//		titlePanel.add(buddyListButton,BorderLayout.WEST);
		titlePanel.add(liButton,BorderLayout.EAST);
		
		buttonPanel.add(rtButton);
		buttonPanel.add(rmButton);
		buttonPanel.add(ncButton);
		buttonPanel.add(biButton);
		buttonPanel.add(brButton);
		buttonPanel.add(bgButton);
		buttonPanel.add(bdButton);
		buttonPanel.add(hbButton);
		buttonPanel.add(coButton);
		buttonPanel.add(foButton);
		buttonPanel.add(msButton);
		buttonPanel.add(mrButton);
		buttonPanel.add(ftButton);

		messagePanel.add(memoButton,BorderLayout.WEST);
		messagePanel.add(messageField,BorderLayout.CENTER);
		messagePanel.add(loButton,BorderLayout.EAST);

//	
		liButton.setBackground(Color.orange);
		rtButton.setBackground(Color.orange);
		rmButton.setBackground(Color.orange);
		ncButton.setBackground(Color.orange);
		biButton.setBackground(Color.orange);
		brButton.setBackground(Color.orange);
		bgButton.setBackground(Color.orange);
		bdButton.setBackground(Color.orange);
		hbButton.setBackground(Color.orange);
		ftButton.setBackground(Color.orange);
		coButton.setBackground(Color.orange);
		foButton.setBackground(Color.orange);
		msButton.setBackground(Color.orange);
		mrButton.setBackground(Color.orange);
		loButton.setBackground(Color.orange);
		
		buddyListButton.setBackground(Color.pink);
		memoButton.setBackground(Color.pink);
		messageArea.setForeground(wColor);
		messageArea.setBackground(bwColor);

//		buddyList.setForeground(Color.blue);
//		buddyList.setBackground(Color.gray);

//	EVENT REGISTRATION
		
		ChatClientEventHandler chatClientEventHandler = new ChatClientEventHandler(this);
		buddyListButton.addActionListener(chatClientEventHandler);
		liButton.addActionListener(chatClientEventHandler);
		rtButton.addActionListener(chatClientEventHandler);
		rmButton.addActionListener(chatClientEventHandler);
		ncButton.addActionListener(chatClientEventHandler);
		biButton.addActionListener(chatClientEventHandler);
		brButton.addActionListener(chatClientEventHandler);
		bgButton.addActionListener(chatClientEventHandler);
		bdButton.addActionListener(chatClientEventHandler);
		hbButton.addActionListener(chatClientEventHandler);
		ftButton.addActionListener(chatClientEventHandler);
		coButton.addActionListener(chatClientEventHandler);
		foButton.addActionListener(chatClientEventHandler);
		msButton.addActionListener(chatClientEventHandler);
		mrButton.addActionListener(chatClientEventHandler);
		loButton.addActionListener(chatClientEventHandler);
		
		memoButton.addActionListener(chatClientEventHandler);
		messageField.addActionListener(chatClientEventHandler);
		messageField.setActionCommand("messageField");

		setSize(450,350);
		setLocation(350,300);
		setVisible(true);
	}

	public void checkLogin(String nick)
	{
		ClientPersistent clientPersistent = new ClientPersistent(nick);
		if (clientPersistent.restore())
		{
			this.nick = nick;
			this.host = nick;
			id = clientPersistent.getId();
			chatName = clientPersistent.getName();
			System.out.println(nick +  "  ̸  : " + chatName);
			connect();
			updateBuddy();
		}
		else
		{
			new LoginDialog(this);
		}
	}
	
	public void updateBuddy()
	{
		BuddyMemoPersistent buddyMemoPersistent = new BuddyMemoPersistent(nick);
		Vector buddyMemoV = buddyMemoPersistent.resultV();
		getBuddyStatus(buddyMemoV);
	}
	
	public void register(String nick,String name,String id,String mail,String age,String sex)
	{
		ClientPersistent clientPersistent = new ClientPersistent(nick,name,id,mail,age,sex);
		if(clientPersistent.save())
		{
			this.nick = nick;
			this.id = id;
			// ο    Ѵ.
			BuddyPersistent buddyPersistent = new BuddyPersistent(nick,"Buddy","Buddy");
			buddyPersistent.save();
			buddyPersistent = new BuddyPersistent(nick,"Buddy","^.^!");
			connect();
			updateBuddy();
		}
		else
		{
			System.out.println("  ϴ.");
		}
	}

	public void connect()
	{		
		try 
		{
			// Open a connection to Assigned URL and PORT
			toServer = new Socket(serverURL, PORT);
			os = toServer.getOutputStream();
			is = toServer.getInputStream();
			oos = new ObjectOutputStream(os);
			ois = new ObjectInputStream(is);
			sendDatum(Datum.NICK_NAME, nick); //   
			sendDatum(Datum.CHAT_ROOM_OPEN,nick);// 
			ClientThread clientThread = new ClientThread(ois,this);
			Thread t = new Thread(clientThread);
			t.start();
			setRoomTitle(nick);			
		} 
		catch (Exception e) 
		{
			System.out.println("Connection failed");
		}
	} // serviceStart

	public void close()
	{		
		sendDatum(Datum.CHAT_CLOSE,nick);// 
		try 
		{
			// When the EOF is reached, close the connection and exit
			os.close();
			is.close();
			oos.close();
			ois.close();
			toServer.close();
		} 
		catch (Exception e) 
		{
			System.out.println("Closing failed");
		}
	} 


	public void setRoomTitle(String str)
	{
		roomTitleLabel.setText(str);
	}

	public void changeRoomTitle(String title)
	{
		System.out.println("  : " + host );
		System.out.println(" ̸ : " + nick );
		if(host.equals(nick))
		{
			sendDatum(Datum.ROOM_TITLE_CHANGE, title);
		}
		else
		{
			sendDatum(Datum.TITLE_CHANGE_REQUEST,title);
		}
	}
	
	public void makeRoom(String title)
	{
		sendDatum(Datum.CHAT_ROOM_OPEN,title) ;
		setRoomTitle(title);
	}
	public void setChatName(String str)
	{
		chatMsg = new ChatMsg();
		chatMsg.setNick(chatName);
		chatName = str;
		chatMsg.setWord( str + "  ̸ مf...    ^.^!  " );
		sendDatum(Datum.CHAT_NAME_CHANGE,chatMsg);
	}
	public void inviteBuddy()
	{
		String to = buddyList.getBuddy();
		String buddyGroup = buddyList.getBuddyGroup();
		if (buddyGroup.equals(to))
		{	// buddyGroup  õ 
			System.out.println("õ  ׷: " + to);
			BuddyPersistent buddyPersistent	= new BuddyPersistent(id, 0,buddyGroup);
			Vector selectGroupV = buddyPersistent.resultV();
			String[] selectGroup = null;
			for	(int i = 0 ; i < selectGroup.length ; i++)
			{
				selectGroup = (String[])selectGroupV.elementAt(i);
				to = selectGroup[1];
				sendDatum(Datum.INVITE_BUDDY,to);
			}
		}
		else
		{
			System.out.println("õ   ʴ븦 մϴ. : " + to);
			sendDatum(Datum.INVITE_BUDDY,to);
		}
	}
	
	public void receiveInvitation(String buddy)
	{
    	int n = JOptionPane.showConfirmDialog(
                new JFrame(), buddy + "  ûԴϴ. ! ʴ뿡 ϰڽϱ ?",
                " -> ʴ <- ", JOptionPane.YES_NO_OPTION);
        if (n == JOptionPane.YES_OPTION) 
        {
        	host = buddy;
			sendDatum(Datum.INVITE_ACCEPT,buddy);
        } 
	}

	public void shareRoomName(String buddy)
	{
		sendDatum(Datum.INVITE_INFO,buddy);
	}
	
	public void changeRoom(String title)
	{
		sendDatum(Datum.INVITE_GUIDE,title);
		setRoomTitle(title);
	}
	

	public void setNewBuddy(String str)
	{
		ClientPersistent clientPersistent = new ClientPersistent(str);
		if(clientPersistent.restore())
		{
			String buddyGroup = buddyList.getBuddyGroup();
			if(buddyGroup == null)
			{
				buddyGroup = "Buddy";
			}
			BuddyPersistent buddyPersistent = new BuddyPersistent(nick,buddyGroup,str);
			if (buddyPersistent.save())
			{
				buddyPersistent = new BuddyPersistent(nick,buddyGroup,"^.^!");
				boolean result = buddyPersistent.remove();
				System.out.println("New Buddy added !");
			}
			updateBuddy();
		}
	}

	public void setNewBuddyGroup(String str)
	{
		String buddyGroup = buddyList.getBuddyGroup();
		System.out.println("buddyGroup  :  " + buddyGroup);
		if(buddyGroup == null)
		{
			buddyGroup = "Buddy";
		}
		BuddyPersistent buddyPersistent = new BuddyPersistent(nick,buddyGroup,str);
		if (buddyPersistent.save())
		{
			buddyPersistent = new BuddyPersistent(nick,str,"^.^!");
			if (buddyPersistent.save())
			{
				updateBuddy();
				System.out.println("New Buddy Group added !");
			}
		}
	}
	
	
	public void setDeleteBuddy(String str)
	{
		String buddyGroup = null;
		BuddyPersistent nodePersistent = new BuddyPersistent(id,str);
		BuddyPersistent brotherPersistent = null;
		if(nodePersistent.restore())
		{
			buddyGroup = nodePersistent.getBuddyGroup();
			brotherPersistent = new BuddyPersistent(id,0,buddyGroup);
			System.out.println("Node deleted : " + nodePersistent.remove());		
		}
		if (! brotherPersistent.restore())
		{
			BuddyPersistent parentPersistent = new BuddyPersistent(id,buddyGroup);
			System.out.println("Folder deleted : " + parentPersistent.remove());
		}
		updateBuddy();
	}
		
	public void removeSelectedBuddy()
	{
		buddyList.removeBuddy();
	}

	public void getBuddyStatus(Vector buddyMemoV)
	{
		sendDatum(Datum.BUDDY_STATUS,buddyMemoV);
	}
	public void setBuddyStatus(Vector buddyStatusV)
	{
		for ( int i = 0 ; i < buddyStatusV.size() ; i++)
		{
			String[] buddyStatusA = (String[])buddyStatusV.elementAt(i); 
			p.r(this,"buddyStatusA[3]",buddyStatusA[3]);
		}
		
		buddyList.updateBuddy(nick,buddyStatusV);
//		buddyList.setBuddyStatus(buddyStatusV);
	}
	
	public void makeMemorandum()
	{
		String to = buddyList.getBuddy();
		memo = new Memorandum(this,"",to);
	}
	public void replyMemorandum()
	{
		String to = memo.getFromBuddy();
		memo = new Memorandum(this,"",to);
	}
	public void sendMemorandum()
	{
		String toBuddy = memo.getToBuddy();
		String content = memo.getContent();
		String fromBuddy = nick;
		System.out.println("toBuddy : "+ toBuddy + " | " + "fromBuddy : " + fromBuddy + " | " + "content : " + content);
		String sendTime = String.valueOf(System.currentTimeMillis());
		memoPersistent = new MemoPersistent(toBuddy,fromBuddy,content,sendTime);
		messageField.setText("");		
		System.out.println(memoPersistent.save());
	}
		
	public void receiveMemorandum()
	{
		String fromBuddy = buddyList.getBuddy();
		String toBuddy = nick;
		System.out.println("\n\n\n------------------------------------");
		memoPersistent = new MemoPersistent(toBuddy,fromBuddy);
		Vector memoV = memoPersistent.resultV();
		if(memoV != null && memoV.size() > 0)
		{
			memoA = new Memorandum[memoV.size()];
			for ( int i = 0 ; i < memoV.size() ; i++)
			{
				String[] column = (String[])memoV.elementAt(i);
				System.out.println("toBuddy : "+ column[0] + " | " + "fromBuddy : " + column[1] + " | " + "content : " + column[2] + " | " + "isRead : " + column[3]);
//				String toBuddy = column[0];
//				String fromBuddy = column[1];
				String content = column[2];
				String sendTime = column[3];
				memoA[i] = new Memorandum(this,"޸",toBuddy,fromBuddy,content,sendTime,i);
			}
		}
	}
		
	public void removeMemorandum(int i)
	{
		String toBuddy = nick;
//		String toBuddy = memoA[i].getBuddy();
		String fromBuddy = memoA[i].getFromBuddy();
//		String toBuddy = memoA[i].getToBuddy(); б⿡ fromBuddy  Ƿ  
		String sendTime = memoA[i].getSendTime();
		memoPersistent = new MemoPersistent(toBuddy,fromBuddy,sendTime);
		System.out.println(memoPersistent.remove());
	}

	public void fileTransfer()
	{
		String to = buddyList.getBuddy();
		String buddyGroup = buddyList.getBuddyGroup();
		if (buddyGroup.equals(to))
		{	// buddyGroup  õ 
			System.out.println("õ  ׷: " + to);
			BuddyPersistent buddyPersistent	= new BuddyPersistent(id, 0,buddyGroup);
			Vector selectGroupV = buddyPersistent.resultV();
			String[] selectGroup = null;
			for	(int i = 0 ; i < selectGroup.length ; i++)
			{
				selectGroup = (String[])selectGroupV.elementAt(i);
				to = selectGroup[1];
				sendDatum(Datum.FILE_TRANSFER,to);
			}
		}
		else
		{
			System.out.println("õ   ȭ մϴ. : " + to);
			sendDatum(Datum.FILE_TRANSFER,to);
		}
	}
	public void fileSend(String clientAddress)
	{
		JFrame fileFrame = new JFrame();
		new FileClient(clientAddress,FILE_PORT, fileFrame);	
	}

	public void setNewHobby(String str)
	{
	}

	public void setWordFont(Font wFont)
	{
		this.wFont = wFont;
		messageArea.setFont(wFont);
		initProperty.setValue("FONT_STRING",wFont.getFontName());
		initProperty.setValue("FONT_SIZE",String.valueOf(wFont.getSize()));
		initProperty.setValue("FONT_STYLE",String.valueOf(wFont.getStyle()));
	}
	
	public void setWordColor(Color wColor)
	{
		this.wColor = wColor;
		messageArea.setForeground(wColor);
		initProperty.setValue("FORE_RED",String.valueOf(wColor.getRed()));		
		initProperty.setValue("FORE_GREEN",String.valueOf(wColor.getGreen()));		
		initProperty.setValue("FORE_BLUE",String.valueOf(wColor.getBlue()));		
	}

	public void setBackWordColor(Color bwColor)
	{
		this.bwColor = bwColor;
		messageArea.setBackground(bwColor);
		initProperty.setValue("BACK_RED",String.valueOf(bwColor.getRed()));		
		initProperty.setValue("BACK_GREEN",String.valueOf(bwColor.getGreen()));		
		initProperty.setValue("BACK_BLUE",String.valueOf(bwColor.getBlue()));		
	}
	
	public void setImageIcon(String fileName)
	{
		wImageIcon = new ImageIcon(fileName);
	}
	
	public void sendChatMessage()
	{
		sendDatum(Datum.CHAT_ONGOING,getChatMessage());
		resetMessageField();
	}

	ChatMsg getChatMessage()
	{
		chatMsg = new ChatMsg();
		chatMsg.setNick(chatName);
		chatMsg.setWord(messageField.getText());
//		chatMsg.setFont(wFont);
//		chatMsg.setColor(wColor);
//		chatMsg.setImageIcon(wImageIcon);
		return chatMsg;
	}

///////////////// JTextField   
	public void setChatMessage(ChatMsg chatMsg)
	{
		String chatWord = chatMsg.getNick() + ": " + chatMsg.getWord() + ENDMARK;
		messageArea.append(chatWord);//ѱȯ
		resetMessageField();
	}
	
	public void sendMemoMessage()
	{
		String to = buddyList.getBuddy();
		String buddyGroup = buddyList.getBuddyGroup();
		ChatMsg chatMsg = new ChatMsg();
		chatMsg.setWord(nick + " -> " + messageField.getText());
		
//		datum = new Datum(Datum.CHAT_MEMO,getChatMessage());
		if (buddyGroup.equals(to))
		{	// buddyGroup  õ 
			System.out.println("õ  ׷: " + to);
			BuddyPersistent buddyPersistent	= new BuddyPersistent(id, 0,buddyGroup);
			Vector selectGroupV = buddyPersistent.resultV();
			String[] selectGroup = null;
			for	(int i = 0 ; i < selectGroup.length ; i++)
			{
				selectGroup = (String[])selectGroupV.elementAt(i);
				to = selectGroup[1];
				chatMsg.setNick(to);
				sendDatum(Datum.CHAT_MEMO,chatMsg);
			}
		}
		else if(to != null)
		{
			chatMsg.setNick(to);
			sendDatum(Datum.CHAT_MEMO,chatMsg);
			System.out.println( to  +  "   ½ϴ. " );
		}
		resetMessageField();
	}	
	
	public void displayMemo(ChatMsg chatMsg)
	{
		String cWord = chatMsg.getWord();
		String cNick = chatMsg.getNick();
		chatMsg.setNick("system");
		chatMsg.setWord( cNick + "  Դϴ....\n" + cWord );
		setChatMessage(chatMsg);		
	}
	
	public void resetMessageField()
	{
		messageField.requestFocus();
		messageField.setText("");
		messageField.requestFocus();
	}
	
	void sendDatum(int status,Object info)
	{
		datum = new Datum(status, info);
		try
		{
			oos.writeObject(datum);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
