import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.event.ListSelectionListener;

class ChatClientEventHandler implements ActionListener, ListSelectionListener, ListDataListener


{
	Client chatClient;
	ChatMsg chatMsg;
	FocusManager textManager;
	
	public ChatClientEventHandler(Client chatClient)
	{
		this.chatClient = chatClient;
		textManager = FocusManager.getCurrentManager();
	}
	
	public void actionPerformed(ActionEvent aE)
	{
		String command = aE.getActionCommand();
		if(command.equals("messageField"))
		{
			chatClient.sendChatMessage();
		}
		else if(command.equals("α׾ƿ"))
		{
			chatClient.close();
		}
		else if(command.equals("<α>"))
		{
			new ChatInfoFrame(chatClient,"<α>");
		}
		else if(command.equals(""))
		{
			new ChatInfoFrame(chatClient,"");	
		}
		else if(command.equals("游"))
		{
			new ChatInfoFrame(chatClient,"游");	
		}
		else if(command.equals("̸"))
		{
			new ChatInfoFrame(chatClient,"̸");
		}
		else if(command.equals("ģʴ"))
		{
			chatClient.inviteBuddy();
		}
		else if(command.equals("ģ"))
		{
			new ChatInfoFrame(chatClient,"ģ");	
		}
		else if(command.equals("׷"))
		{
			new ChatInfoFrame(chatClient,"׷");	
		}
		else if(command.equals(""))
		{
			chatClient.removeSelectedBuddy();	
		}
		else if(command.equals("ȣ"))
		{
			new ChatInfoFrame(chatClient,"ȣ");	
		}
		else if(command.equals("ۻ"))
		{
			new ChatColor(chatClient);	
		}
		else if(command.equals("۲ú"))
		{
			new ChatFont(chatClient);	
		}
		else if(command.equals("޸"))
		{
			chatClient.makeMemorandum();	
		}
		else if(command.equals("޸"))
		{
			chatClient.receiveMemorandum();	
		}
		else if(command.equals("ȭ"))
		{
			chatClient.fileTransfer();	
		}
		
		else if(command.equals(" ģ"))
		{
			chatClient.updateBuddy();	
		}
		else if(command.equals("[ ]"))	
		{
			chatClient.sendMemoMessage();	
		}
	}
	
	public void	contentsChanged(ListDataEvent e)
	{
		System.out.println("\n\n\ncontentsChanged");
	}
	
 	public void	intervalAdded(ListDataEvent e)
 	{
		System.out.println("\n\n\nintervalAdded");
 	}
 	
	public void	intervalRemoved(ListDataEvent e)
	{
		System.out.println("\n\n\nintervalRemoved");
		
	}
	
	public void valueChanged(ListSelectionEvent slE)
	{
		JList comp = (JList)slE.getSource();
		int no =comp.getSelectedIndex();
		System.out.println(no);
		System.out.println("\n\n\n");
	}

}


	

