// FILE: c:/temp/SMCHATTING/ClientChannelT.java
// 2001.8.6
// Rev : org
//package SMCHATTING;
import java.util.*;
import java.io.*;

public class ClientChannelT extends Hashtable
{
    static private ClientChannelT instance = (ClientChannelT)null;       
    // Singleton & Double-Checked Locking
    static public ClientChannelT getClientChannelT() 
    {
        if (instance == null) 
        {
            synchronized(ClientChannelT.class) 
            {
                if (instance == null) 
                {
                    instance = new ClientChannelT();
                }
            }
        }
        return instance;
    }

    synchronized void addClientChannel(String nick, RoomMate roomMate)
    {
    	put(nick,roomMate);
    	System.out.println(" registered in hashTable ");
    	System.out.println("   roomMate  : " + (RoomMate)get(nick));
    }

    synchronized RoomMate getClientChannel(String nick)
    {
    	RoomMate roomMate = (RoomMate)get(nick);
    	System.out.println(" pull out from hashTable, roomMate  մϴ.");
    	System.out.println(" ˻  roomMate  : " + roomMate);
    	return roomMate;
    }

    synchronized void removeClientChannel(String nick)
    {
		remove(nick);
	}
		
} /* end class ClientChannelT */
