import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

class FileClient extends JDialog implements FileClientFace
{
	final int PORT ;// ȭ   Ʈ 9999 Ʈ 
	final String serverURL; //  ּ   ͳּҷ ġ
	final static int ROW =3;
	final static int COLUMN = 30;
	final int X = 280;
	final int Y = 120;
	final String FILE_LABEL = "ȭ";
	JFrame fileFrame;
	final int XLoc = 300;
	final int YLoc = 250;
	JTextArea messageArea = new JTextArea(ROW,COLUMN);
	JTextField fileField = new JTextField(COLUMN);

	public FileClient(String serverURL, int PORT, JFrame fileFrame)
	{
		super(fileFrame, "File sending Dialog", true);
		this.fileFrame = fileFrame;
		this.serverURL = serverURL;
		this.PORT = PORT;
		init();
	}
	
	void init()
	{
		msg("init");
		JLabel fileLabel = new JLabel(FILE_LABEL);
		JLabel sendLabel = new JLabel(" ޽");
		JButton fileButton = new JButton("ȭϼ");
		JButton sendButton = new JButton("");
//		JButton tmpButton = new JButton(" ");
		JLabel nullLabel = new JLabel("  ");
		msg("init-fileClientHandler1");
		FileClientHandler fileClientHandler = new FileClientHandler(fileFrame,this);
		msg("init-FileClientHandler2");
		fileButton.addActionListener(fileClientHandler);
		sendButton.addActionListener(fileClientHandler);
		Container contentPane = getContentPane();
		JPanel rightPanel = new JPanel();
		JPanel leftPanel = new JPanel();
		
		rightPanel.setLayout(new GridLayout(4,1));
		leftPanel.setLayout(new GridLayout(4,1));
		
		contentPane.setLayout(new BorderLayout());
		
		contentPane.add(leftPanel,BorderLayout.CENTER);
		contentPane.add(rightPanel,BorderLayout.EAST);

		leftPanel.add(fileLabel);
		leftPanel.add(fileField);
		leftPanel.add(sendLabel);
		leftPanel.add(messageArea);
		rightPanel.add(fileButton);
		rightPanel.add(nullLabel);
		rightPanel.add(nullLabel);
		rightPanel.add(sendButton);
		
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setSize(X,Y);
		setLocation(XLoc,YLoc);
		setVisible(true);
		
	}
	public void setFileName(File selectedFile)
	{
		fileField.setText(selectedFile.getPath());
	}
	
	
	public void sendFile(File selectedFile)
	{
		new FileSender(selectedFile,serverURL ,PORT,this);
	}
	
	public void close()
	{
		dispose();
	}
	

/*
	public static void main(String args[])
	{
		FileClient fileClient = new FileClient("127.0.0.1",new JFrame());
		fileClient.init();
	}
*/
	static int MSG_NO;
	String className =" FileDialog   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}		
	
	
	
}
