import java.io.*;
import java.net.*;

class FileSender
{
	//ӽ  뷮 1 k byte  
		String serverURL;
		int PORT;
		final static int BUFF_SIZE = 1024;
		byte[] data = new byte[BUFF_SIZE];
		OutputStream os;// ȭ   ¸  
		InputStream is;// ȭ  ޱ 
		ObjectInputStream ois;// ȭ    ޱ 
		ObjectOutputStream oos;//ȭ Ż¸  
		FileInputStream fis; // ȭ ϱ 
		Datum datum;
		String fileName;
		File sendingFile;
		FileClientFace fileClient;
/*
	public static void main(String args[])
	{
		while (args.length < 1)
		{
			System.out.println("useage : java FileSender <file to be sent>");
			break;
		}
		try
		{
			FileSender smFileSender = new FileSender();
			smFileSender.init(args[0]);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	
*/

	public FileSender(File sendingFile,String serverURL, int PORT,FileClientFace fileClient)
	{
		this.serverURL = serverURL;
		this.PORT = PORT;
		this.sendingFile = sendingFile;
		this.fileClient = fileClient;
		fileName = sendingFile.getName();
		msg("fileName",fileName);
		try
		{
			init();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
	}

	void init() throws Exception
	{
		msg("serverURL",serverURL);
		msg("PORT",PORT);
		
		Socket toServer = new Socket(serverURL, PORT);//  Ͽ  
		makePipe(toServer);// Ͽ  ̹ 
		receiveInfo();//FILE_NAME
		receiveInfo();//FILE_START
		receiveInfo();//FILE_SIZE
		receiveInfo();//TRANS_STOP
		toServer.close();//  ݴ´.
	}
	
	void sendInfo(int status, Object info) throws Exception
	{
		datum = new Datum(status,info);
		datum.print();
		oos.writeObject(datum);
	}
	
	void receiveInfo() throws Exception
	{
		datum = (Datum)(ois.readObject());
		datum.print();
		int status = datum.getStatus();
	    switch (status) 
	    {
			case Datum.FILE_NAME:  
			{
				sendInfo(Datum.FILE_NAME,fileName); 
				break;
			}
			case Datum.TRANS_START: sendFile(); break;
			case Datum.TRANS_STOP:
			{
				closePipe();
				fileClient.close();
//				System.exit(0); //////////  
				break;
			}
			case Datum.FILE_DENY:
			{
				closePipe();
				fileClient.close();
				System.exit(0); //////////  
				break;
			}
			case Datum.FILE_SIZE:   
			{
				sendInfo(Datum.FILE_SIZE,String.valueOf(sendingFile.length()));
				break;
			}
		}
	}
		
	void makePipe(Socket toServer) throws Exception
	{
		os = toServer.getOutputStream();
		is = toServer.getInputStream();
		oos = new ObjectOutputStream(os);
		ois = new ObjectInputStream(is);
		fis = new FileInputStream(sendingFile);
	}
	
	void sendFile() throws Exception
	{
		int count;
		while((count = fis.read(data)) > -1)
		{
			os.write(data,0,count);
			count = 0;
		}
	}
	void closePipe() throws Exception//  ̹ ݴ´.
	{
		fis.close();
		oos.close();
		ois.close();
		os.close();
		is.close();
	}
	static int MSG_NO;
	String className =" FileSender   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}		
}
		
			