//
// ѽ¹
//2001.9.17
//package exception.util


import java.util.*;
import java.io.*;

public class InitProperty extends Hashtable
{
    static private InitProperty instance;  
	static String FILE_NAME="init.properties"; 
    static public InitProperty getInstance() 
    {
        if (instance == null) 
        {
            synchronized(InitProperty.class) 
            {
                if (instance == null) 
                {
                    instance = new InitProperty();
                }
            }
        }
        return instance;
    }

    public InitProperty() 
    {
        init();
    }

	void init() 
	{
		String line;
		String name;
		String value;
		try
		{
			File propertyFile = new File(FILE_NAME);
			FileReader fr = new FileReader(propertyFile);
			BufferedReader br = new BufferedReader(fr);
			while( null !=( line = br.readLine()))
			{
				StringTokenizer token = new StringTokenizer(line,"=");
				while(token.hasMoreTokens())
				{
					name = token.nextToken();
					value = token.nextToken();
					put(name,value);
				}
			}
			br.close();
			fr.close();
		}
		
		catch(IOException ioE)
		{
			ioE.printStackTrace();
		}
		
		catch(Exception E)
		{
			E.printStackTrace();
		}
	}
	public String getValue(String name)
	{
		return (String)get(name);
	}
	public void setValue(String name, String value)
	{
		put(name,value);
		Enumeration enum = keys();
		PrintWriter outWriter = null;
		try
		{
			outWriter = new PrintWriter(new FileOutputStream(FILE_NAME));
		}
		catch(FileNotFoundException fnE)
		{
			fnE.printStackTrace();
		}
		String keyName = null;
		while(enum.hasMoreElements()) 
		{
			keyName = (String)enum.nextElement();
			System.out.println(keyName + "=" + p.e2h((String)get(keyName)));
			outWriter.println(keyName+"="+p.h2e((String)get(keyName)));
			
		}
		outWriter.flush();
		outWriter.close();
	}
}

