//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
//package database;
import java.util.*;

/*	memorandum Table schima
       (nick 	VARCHAR2(20),
        buddy 	VARCHAR2(20),
        content	VARCHAR2(1024),
        isread	VARCHAR2(1),
		CONSTRAINT	memorandum_id_primary PRIMARY KEY (nick, buddy)
       );
*/	

class MemoPersistent extends Persistent 
{
	PersistentPeer persistentPeer;
	//   String id;
	String toBuddy;
	String fromBuddy;
	String content;
	String sendTime;
	
	String COMMA = ",";
	String START = "(";
	String END = ")";

	String AND = " and ";
	String OR = " or ";
	String EQUAL = " = ";
	
	String query;
	String insertSql;
	String deleteSql;
	String updateSql;
	
	public MemoPersistent(String toBuddy, String fromBuddy,String content,String sendTime) 
	{
		this.toBuddy = toBuddy;
		this.fromBuddy = fromBuddy;
		this.content = content;
		this.sendTime = sendTime;
		setInsertSql("toBuddy",toBuddy,"fromBuddy",fromBuddy,"content",content,"sendTime",sendTime);
		
		setQuery("toBuddy",toBuddy, "fromBuddy", fromBuddy,"content",content,"sendTime",sendTime );
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public MemoPersistent(String toBuddy,String fromBuddy,String sendTime)
	{
		this.toBuddy = toBuddy;
		this.fromBuddy = fromBuddy;
		this.sendTime = sendTime;
		setQuery("toBuddy",toBuddy,"fromBuddy",fromBuddy,"sendTime",sendTime);
		setDeleteSql("toBuddy",toBuddy,"fromBuddy",fromBuddy,"sendTime",sendTime);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public MemoPersistent(String toBuddy,String fromBuddy)
	{
		this.toBuddy = toBuddy;
		this.fromBuddy = fromBuddy;
		setQuery("toBuddy",toBuddy,"fromBuddy",fromBuddy);
		setDeleteSql("toBuddy",toBuddy,"fromBuddy",fromBuddy);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public MemoPersistent(String toBuddy)
	{
		this.toBuddy = toBuddy;
		setQuery("toBuddy",toBuddy);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	
  
/*
	void setPersistentPeer(PersistentPeer concreteDatabasePeer)
	{
		this.persistentPeer = concreteDatabasePeer;
	}
*/	
	void setQuery(String columnName,  String condition) 
	{
		query = "select toBuddy,fromBuddy,content,sendTime FROM memorandum WHERE " + columnName + EQUAL + makeStr(condition); 
		System.out.println("setQuery() : "+query);
	}

	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		query = "select toBuddy,fromBuddy,content,sendTime FROM memorandum WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) ; 
		System.out.println("setQuery() : "+query);
	}
	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3, String condition3) 
	{
		query = "select toBuddy,fromBuddy,content,sendTime FROM memorandum WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) + AND + columnName3 + EQUAL + makeStr(condition3) ; 
		System.out.println("setQuery() : "+query);
	}
	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3, String condition3, String columnName4, String condition4) 
	{
		query = "select toBuddy,fromBuddy,content,sendTime FROM memorandum WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) + AND + columnName3 + EQUAL + makeStr(condition3) + AND + columnName4 + EQUAL + makeStr(condition4) ; 
		System.out.println("setQuery() : "+query);
	}

	void setDeleteSql(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		deleteSql = "delete from memorandum where " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2); 
		System.out.println("setDeleteSql() : "+ deleteSql);
	}
	void setDeleteSql(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3,  String condition3) 
	{
		deleteSql = "delete from memorandum where " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) + AND + columnName3 + EQUAL + makeStr(condition3); 
		System.out.println("setDeleteSql() : "+ deleteSql);
	}

	void setInsertSql(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3,  String condition3, String columnName4,  String condition4) 
	{
		insertSql = "insert into memorandum(toBuddy,fromBuddy,content,sendTime) values" + START + makeStr(condition1) + COMMA + makeStr(condition2)+ COMMA + makeStr(condition3) + COMMA + makeStr(condition4) + END;
		System.out.println("setInsertSql() : "+ insertSql);
	}

	PersistentPeer getPersistentPeer()
	{
		return persistentPeer;/////////////////
	}
	String getInsertSql()
	{
		return h2e(insertSql);
	}
	String getDeleteSql()
	{
		return h2e(deleteSql);
	}
	String getUpdateSql()
	{
		return h2e(updateSql);
	}
	String getSelectSql()
	{
		return h2e(query);
	}
////////////////////// Test  ʿ	
	boolean struct(Vector tableV)
	{
		if(tableV.size() > 0)
		{
			String[] column = (String[])(tableV.elementAt(0));
			toBuddy = column[0];
			fromBuddy = column[1];
			content = column[2];
			sendTime = column[3];
			return true;
		}
		else
		{
			return false;
		}
	}
	
	Vector reStruct(Vector tableV) // ʿ ׸   
	{
		Vector newTableV = new Vector(0,1);
		String[] newColumn;
		String column[];
		for( int i = 0 ; i < tableV.size() ; i++ )
		{
			System.out.println( "reStruct() : "  + i );
			column = (String[])(tableV.elementAt(i));
			newColumn = new String[4];
			newColumn[0] = column[0];
			newColumn[1] = column[1];
			newColumn[2] = column[2];
			newColumn[3] = column[3];
			newTableV.addElement(newColumn);
		}
		return newTableV;
	}
		
///////////////////////////////////////////////	
	void print(int no)
	{
		System.out.println( "\n\n**********memorandum persistent : " + no + "******\n" );
		System.out.print( "toBuddy : " + toBuddy );
		System.out.print( "  |   ");
		System.out.print( "fromBuddy : " + fromBuddy );
		System.out.print( "  |   ");
		System.out.print( "content : " + content );
		System.out.print( "  |   ");
		System.out.print( "sendTime : " + sendTime );
		System.out.println( "\n************************************************************\n\n" );
	}

	void print()
	{
		print(0);
	}
	
	
	String makeStr(String str)
	{
		return "\'" + str + "\'";
	}
	String getToBuddy()
	{
		return toBuddy;
	}
	
	String getFromBuddy()
	{
		return fromBuddy;
	}
	String getContent()
	{
		return content;
	}

	String getIsRead()
	{
		return sendTime;
	}
} /* end class ConcretePersistent */
