import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

class Memorandum extends JFrame implements ActionListener
{
	Client chatClient;
	JTextField fieldBuddy;
	JTextArea areaContent;
	String buttonName;
	String labelName;
	String toBuddy;
	String fromBuddy;
	String content;
	String sendTime;
	int index;
	
	public Memorandum(Client chatClient,String buttonName,String toBuddy)
	{
		this.chatClient = chatClient;
		this.buttonName = buttonName;
		this.toBuddy = toBuddy;
		init();
		pack();
		setLocation(250,180);
		setVisible(true);
	}
	public Memorandum(Client chatClient,String buttonName,String toBuddy,String fromBuddy,String content,String sendTime, int index )
	{
		this.chatClient = chatClient;
		this.buttonName = buttonName;
		this.toBuddy = toBuddy;
		this.fromBuddy = fromBuddy;
		this.content = content;
		this.sendTime = sendTime;
		this.index = index;
		System.out.println("----------------------- ");
		System.out.println("Memorandum()-fromBuddy : "+fromBuddy);
		System.out.println("Memorandum()-content : "+content);
		
		init();
		setMemo();
		pack();
		setLocation(250,120);
		setVisible(true);
	}
	
	void init()
	{
		JButton buttonTo = new JButton( " Buddy  : ");
		fieldBuddy 	= new JTextField(20);
		fieldBuddy.setText(toBuddy);
		
		areaContent = new JTextArea(8,20);
		
//		JButton buttonSend = new JButton( "");
		JButton buttonSend = new JButton( buttonName);
		JButton buttonCancel = new JButton( "");
	
		JPanel panelHead = new JPanel();
		JPanel panelFoot = new JPanel();
		
		Container memoContnainer = getContentPane();
		
		memoContnainer.add(panelHead,BorderLayout.NORTH);
		memoContnainer.add(areaContent,BorderLayout.CENTER);
		memoContnainer.add(panelFoot,BorderLayout.SOUTH);
		
		panelHead.add(buttonTo);
		panelHead.add(fieldBuddy);
		
		panelFoot.add(buttonSend);
		panelFoot.add(buttonCancel);
		
		buttonSend.addActionListener(this);
		buttonCancel.addActionListener(this);
	}
	
	void setMemo()
	{
		System.out.println("----------------------- ");
		System.out.println("setMemo()-fromBuddy : "+fromBuddy);
		System.out.println("setMemo()-content : "+content);
		fieldBuddy.setText(fromBuddy);
		areaContent.setText(content);
	}
	
	String getToBuddy()
	{
		return fieldBuddy.getText();
	}
	
	String getFromBuddy()
	{
		return fromBuddy;
	}
	
	String getContent()
	{
		return areaContent.getText().trim();
	}
	String getSendTime()
	{
		return sendTime;
	}

	public void actionPerformed(ActionEvent aE)
	{
		String command = aE.getActionCommand();
		if ( command.equals(""))
		{
			chatClient.sendMemorandum();
			this.dispose();
		}
		else if ( command.equals("޸"))
		{
			chatClient.removeMemorandum(index );
			this.dispose();
		}
		else if ( command.equals(" Buddy  : "))
		{
			chatClient.replyMemorandum();
		}
		else
		{
			this.dispose();
		}
	}
}

