//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
//package database;
import java.util.*;
import java.io.*;


abstract class Persistent 
{
	Vector tableV;	

	boolean isNew()
	{
		tableV = getPersistentPeer().query();
		return (tableV.size() == 0 ? true : false );
	}
	boolean save()
	{
		return( isNew() ? getPersistentPeer().insert() : false) ;
	}
	boolean restore()
	{
		return ( !isNew() ? struct(tableV) : false);
	}

	Vector resultV()
	{	
		return ( !isNew() ? tableV : null);
	}
	boolean remove()
	{
		return (!isNew() ? getPersistentPeer().delete() : false);
	}
	abstract boolean struct(Vector tableV);
	abstract Vector reStruct(Vector tableV);
	abstract PersistentPeer getPersistentPeer();
	abstract String getInsertSql();
	abstract String getDeleteSql();
	abstract String getUpdateSql();
	abstract String getSelectSql();

	public String e2h(String en)
	{
		String han=null;
		if(en==null)throw new NullPointerException("Parameter is Null");
		try
		{
			han=new String(en.getBytes("ISO8859_1"),"euc-kr");
		}
		catch(UnsupportedEncodingException ue)
		{
//			throw new CodeException(ue);
		}
		return han;
	}
	public String h2e(String han)
	{
		String en=null;
		if(han==null)throw new NullPointerException("Parameter is Null");
		try
		{
			en=new String(han.getBytes("euc-kr"),"ISO8859_1");
		}
		catch(UnsupportedEncodingException ue)
		{
//			throw new CodeException(ue);
		}
		return en;
	}

} /* end class Persistent */
