drop table if exists client;

CREATE TABLE client
       (
       	nick 	VARCHAR(20) not null,
        name 	VARCHAR(20),
        id 		VARCHAR(40),
        email	VARCHAR(40),
        age		VARCHAR(3),
        sex		VARCHAR(1),
		primary key(nick)
       );

INSERT INTO client  VALUES
        ('simon','ѽ¹','600904','kidsfriend@hanmail.net','42','1');
INSERT INTO client  VALUES
        ('mama','ض','640905','kidsmama@hanmail.net','39','2');
INSERT INTO client  VALUES
        ('tangza','Ѽ','900730','kidsworld@hanmail.net','12','1');
INSERT INTO client  VALUES
        ('joon','Ѽ','921106','kidsland@hanmail.net','10','1');
INSERT INTO client  VALUES
        ('a','aa','1','zxk77@hanmir.com','10','1');
INSERT INTO client  VALUES
        ('b','bb','2','kidsland@hanmail.net','1','1');
INSERT INTO client  VALUES
        ('c','cc','3','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('d','dd','4','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('e','ee','5','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('f','ff','6','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('g','gg','7','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('h','hh','8','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('i','ii','9','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('j','jj','10','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('k','kk','11','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('l','ll','12','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('m','mm','13','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('n','nn','14','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('o','oo','15','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('p','pp','16','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('q','qq','17','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('r','rr','18','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('s','ss','19','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('t','tt','20','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('u','uu','21','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('v','vv','22','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('w','ww','23','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('x','xx','24','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('y','yy','25','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('z','zz','26','zxk77@hanmir.com','1','1');
INSERT INTO client  VALUES
        ('^.^!','dummy','000000','000000','000','0');

drop table if exists buddy;

CREATE TABLE buddy
       (
     	nick		VARCHAR(40) not null,
        buddyGroup 	VARCHAR(20) not null,
       	buddy		VARCHAR(20) not null,
	primary key (nick,buddyGroup,buddy)
       );

INSERT INTO buddy  VALUES
        ('mama','Buddy', 'joon');
INSERT INTO buddy  VALUES
        ('tangza','Buddy', 'simon');
INSERT INTO buddy  VALUES
        ('tangza','Buddy', 'mama');
INSERT INTO buddy  VALUES
        ('joon','Buddy', 'tangza');
INSERT INTO buddy  VALUES
        ('mama','Buddy', 'tangza');
INSERT INTO buddy  VALUES
        ('simon','Buddy', 'mama');
INSERT INTO buddy  VALUES
        ('simon','Buddy','tangza');
INSERT INTO buddy  VALUES
        ('simon','Buddy','joon');
INSERT INTO buddy  VALUES
        ('simon','Java','a');
INSERT INTO buddy  VALUES
        ('simon','Java','b');
INSERT INTO buddy  VALUES
        ('simon','Java','c');
INSERT INTO buddy  VALUES
        ('simon','Java','d');
INSERT INTO buddy  VALUES
        ('simon','Java','e');
INSERT INTO buddy  VALUES
        ('simon','Buddy','Java');
INSERT INTO buddy  VALUES
        ('simon','Buddy','School');
INSERT INTO buddy  VALUES
        ('simon','School','w');
INSERT INTO buddy  VALUES
        ('simon','School','x');
INSERT INTO buddy  VALUES
        ('simon','School','y');
INSERT INTO buddy  VALUES
        ('simon','School','z');
INSERT INTO buddy  VALUES
        ('000000','Buddys','Buddy');

drop table if exists buddystatus;

CREATE TABLE buddystatus
       (
       	nick 	VARCHAR(20) not null,
        Line 	VARCHAR(1),
	 PRIMARY KEY (nick)
       );

INSERT INTO buddystatus  VALUES 
        ('simon','1');
INSERT INTO buddystatus  VALUES 
        ('mama','1');
INSERT INTO buddystatus  VALUES 
        ('tangza','1');
INSERT INTO buddystatus  VALUES 
        ('joon','1');
INSERT INTO buddystatus  VALUES 
        ('a','1');
INSERT INTO buddystatus  VALUES 
        ('b','0');
INSERT INTO buddystatus  VALUES 
        ('c','1');
INSERT INTO buddystatus  VALUES 
        ('d','0');
INSERT INTO buddystatus  VALUES 
        ('e','1');
INSERT INTO buddystatus  VALUES 
        ('f','0');
INSERT INTO buddystatus  VALUES 
        ('g','1');
INSERT INTO buddystatus  VALUES 
        ('h','0');
INSERT INTO buddystatus  VALUES 
        ('i','1');
INSERT INTO buddystatus  VALUES 
        ('j','0');
INSERT INTO buddystatus  VALUES 
        ('k','1');
INSERT INTO buddystatus  VALUES 
        ('l','0');
INSERT INTO buddystatus  VALUES 
        ('m','1');
INSERT INTO buddystatus  VALUES 
        ('n','0');
INSERT INTO buddystatus  VALUES 
        ('o','1');
INSERT INTO buddystatus  VALUES 
        ('p','0');
INSERT INTO buddystatus  VALUES 
        ('q','1');
INSERT INTO buddystatus  VALUES 
        ('r','0');
INSERT INTO buddystatus  VALUES 
        ('s','1');
INSERT INTO buddystatus  VALUES 
        ('t','0');
INSERT INTO buddystatus  VALUES 
        ('u','1');
INSERT INTO buddystatus  VALUES 
        ('v','0');
INSERT INTO buddystatus  VALUES 
        ('w','1');
INSERT INTO buddystatus  VALUES 
        ('x','0');
INSERT INTO buddystatus  VALUES 
        ('y','1');
INSERT INTO buddystatus  VALUES 
        ('z','0');

drop table if exists memorandum;

CREATE TABLE memorandum

       (toBuddy 	VARCHAR(20),
        fromBuddy 	VARCHAR(20),
        content	VARCHAR(104),
        sendTime	VARCHAR(20)
       );

INSERT INTO memorandum  VALUES 
        ('simon','mama','  ','1');
INSERT INTO memorandum  VALUES 
        ('mama','tangza','  ','2');
INSERT INTO memorandum  VALUES 
        ('tangza','joon',' Ϳ κ','3');
INSERT INTO memorandum  VALUES 
        ('joon','simon','ƺ  Ϳ ','4');
drop table if exists hobby;
CREATE TABLE hobby
       (
     	id 		VARCHAR(40),
       	hobby	VARCHAR(20) not null,
        hobbygroup 	VARCHAR(20) not null,
	PRIMARY KEY (hobbygroup,hobby)
       );

INSERT INTO buddy  VALUES
        ('600904','H/W','COMPUTER');
INSERT INTO buddy  VALUES
        ('640905','S/W','COMPUTER');
INSERT INTO buddy  VALUES
        ('900730','GAME','COMPUTER');
INSERT INTO buddy  VALUES
        ('MASTER','COMPUTER','root');
INSERT INTO buddy  VALUES
        ('900730','BASKET','SPORTS');
INSERT INTO buddy  VALUES
        ('921106','SKATE','SPORTS');
INSERT INTO buddy  VALUES
        ('MASTER','SPORTS','root');
INSERT INTO buddy  VALUES
        ('640905','COOK','HOUSE');
INSERT INTO buddy  VALUES
        ('640905','WASH','HOUSE');
INSERT INTO buddy  VALUES
        ('640905','HOUSE','HOUSE');
