//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
//package database;
import java.util.*;

/*	Buddy Table schima
      (
     	nick 		VARCHAR2(40),
       	buddy	VARCHAR2(20),
        buddygroup 	VARCHAR2(20),
        isgroup 	VARCHAR2(1),
		CONSTRAINT	buddy_nick_primary PRIMARY KEY (nick,buddy,buddygroup),
		CONSTRAINT	buddy_buddy_fk FOREIGN KEY (buddy) REFERENCES client(nick) 
				on delete cascade
       );
*/

class BuddyPersistent extends Persistent 
{
	PersistentPeer persistentPeer;
	//   String nick;
	String nick = null;
	String buddy = null;
	String buddyGroup = null;
	String isGroup = null;
	
	String COMMA = ",";
	String START = "(";
	String END = ")";
	String AND = " and ";
	String OR = " or ";
	String EQUAL = " = ";
	
	String query;
	String insertSql;
	String deleteSql;
	String updateSql;

	public BuddyPersistent(String nick,  String buddyGroup, String buddy) 
	{
		this.nick = nick;
		this.buddyGroup = buddyGroup;
		this.buddy = buddy;
		setQuery("nick",nick,"buddyGroup",buddyGroup,"buddy",buddy );
		setInsertSql("nick",nick,"buddyGroup",buddyGroup,"buddy",buddy );
		setDeleteSql("nick",nick,"buddyGroup",buddyGroup,"buddy",buddy );
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public BuddyPersistent(String nick,int dummy, String buddyGroup)
	{
		this.nick = nick;
		this.buddyGroup = buddyGroup;
		setQuery("nick",nick,"buddyGroup",buddyGroup);
		setDeleteSql("nick",nick,"buddy",buddyGroup);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	
	public BuddyPersistent(String nick, String buddy)
	{
		this.nick = nick;
		this.buddy = buddy;
		setQuery("nick",nick,"buddy",buddy);
		setDeleteSql("nick",nick,"buddy",buddy);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	
 	public BuddyPersistent(String nick)
	{
		this.nick = nick;
		setQuery("nick",nick);
		persistentPeer = new ConcreteDatabasePeer(this);
	}

	void setQuery(String columnName,  String condition) 
	{
		query = "select nick,buddyGroup,buddy FROM buddy WHERE " + columnName + EQUAL + makeStr(condition); 
		System.out.println("setQuery() : "+ query);
	}

	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		query = "select nick,buddyGroup,buddy FROM buddy WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2); 
		System.out.println("setQuery() : "+ query);
	}

	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3,  String condition3) 
	{
		query = "select nick,buddygroup,buddy FROM buddy WHERE " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) + AND + columnName3 + EQUAL + makeStr(condition3); 
		System.out.println("setQuery() : "+ query);
	}

	void setDeleteSql(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		deleteSql = "delete from buddy where " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2); 
		System.out.println("setDeleteSql() : "+ deleteSql);
	}

	void setDeleteSql(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3,  String condition3) 
	{
		deleteSql = "delete from buddy where " + columnName1 + EQUAL + makeStr(condition1) + AND + columnName2 + EQUAL + makeStr(condition2) + AND + columnName3 + EQUAL + makeStr(condition3); 
		System.out.println("setDeleteSql() : "+ deleteSql);
	}

	void setInsertSql(String columnName1,  String condition1, String columnName2,  String condition2, String columnName3,  String condition3) 
	{
		insertSql = "insert into buddy(nick,buddyGroup,buddy) values" +  START + makeStr(condition1) + COMMA + makeStr(condition2) + COMMA + makeStr(condition3) + END; 
		System.out.println("setInsertSql() : "+ insertSql);
	}

	PersistentPeer getPersistentPeer()
	{
		return persistentPeer;/////////////////
	}
	String getInsertSql()
	{
		return e2h(insertSql);
	}
	String getDeleteSql()
	{
		return e2h(deleteSql);
	}
	String getUpdateSql()
	{
		return e2h(updateSql);
	}
	String getSelectSql()
	{
		return e2h(query);
	}
////////////////////// Test  ʿ	
	boolean struct(Vector tableV)
	{
		if(tableV.size() > 0)
		{
			String[] column = new String[3];
			for ( int no = 0 ; no < tableV.size() ; no++ )
			{
				column = (String[])(tableV.elementAt(no));
				setNick(h2e(column[0]));
				setBuddy(h2e(column[1]));
				setBuddyGroup(h2e(column[2]));
//				setIsGroup(column[3]);
				print(no);
			}
			return true;
		}
		else
		{
			setNick(null);
			setBuddy(null);
			setBuddyGroup(null);
//			setIsGroup(null);
			return false;
		}
	}
	
	Vector reStruct(Vector tableV)// ϴ 迭  
	{
		Vector newTableV = new Vector(0,1);
		String[] newColumn;
		String column[];
		System.out.println( "reStruct() : "  + "start" );
		for( int i = 0 ; i < tableV.size() ; i++ )
		{
			System.out.println( "reStruct() : "  + i );
			column = (String[])(tableV.elementAt(i));
			newColumn = new String[2];
			newColumn[0] = h2e(column[1]);
			newColumn[1] = h2e(column[2]);
			newTableV.addElement(newColumn);
		}
		return newTableV;
	}
			
			
///////////////////////////////////////////////	
	void print(int no)
	{
		System.out.println( "\n\n*****************" + no + "*********************************\n" );
		System.out.print( "nick : " + nick );
		System.out.print( "  |   ");
		System.out.print( "buddyGroup : " + buddyGroup );
		System.out.print( "  |   ");
		System.out.print( "buddy : " + buddy );
		System.out.print( "  |   ");
//		System.out.print( "isGroup : " + isGroup );
		System.out.println( "\n************************************************************\n\n" );
	}

	void print()
	{
		print (0);
	}
	
	
	String makeStr(String str)
	{
		return "\'" + str + "\'";
	}
	
	void setNick(String nick)
	{
		this.nick = nick;
	}
	
	void setBuddy(String buddy)
	{
		this.buddy = buddy;
	}
	void setBuddyGroup(String buddyGroup)
	{
		this.buddyGroup = buddyGroup;
	}

	void setIsGroup(String isGroup)
	{
		this.isGroup = isGroup;
	}

	String getNick()
	{
		return nick;
	}
	
	String getBuddy()
	{
		return buddy;
	}
	String getBuddyGroup()
	{
		return buddyGroup;
	}

	String getIsGroup()
	{
		return isGroup;
	}

} /* end class ConcretePersistent */
