import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.ActionListener;

class ChatInfoFrame extends JFrame implements ActionListener
{
	Client chatClient;
	public ChatInfoFrame(Client chatClient,String title)
	{
		super();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		this.chatClient = chatClient;
		Container content = getContentPane();
		content.setLayout(new GridLayout(2,1));
		JLabel chatInfoLabel = new JLabel(title);
		JTextField chatInfoField = new JTextField(12);
		chatInfoField.setActionCommand(title);
		content.add(chatInfoLabel);
		content.add(chatInfoField);
		chatInfoField.addActionListener(this);
		pack();
		setLocation(750,320);
		setVisible(true);
		
	}

	public void actionPerformed(ActionEvent aE)
	{
		String command = aE.getActionCommand();
		if (command.equals("<α>"))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.checkLogin(str);
			dispose();
		}
		else if (command.equals(""))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.changeRoomTitle(str);
			dispose();
		}
		else if (command.equals("游"))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.makeRoom(str);
			dispose();
		}
		else if (command.equals("̸"))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.setChatName(str);
			dispose();
		}
		else if (command.equals("ģ"))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.setNewBuddy(str);
			dispose();
		}
		else if (command.equals("׷"))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.setNewBuddyGroup(str);
			dispose();
		}
		else if (command.equals("ȣ"))
		{
			String str = ((JTextField)aE.getSource()).getText();
			chatClient.setNewHobby(str);
			dispose();
		}
	}
}
	
		
		 