import java.io.*;
import java.io.Serializable;
import java.awt.*;
import javax.swing.*;

class ChatMsg implements Serializable
{
	String cNick;
	String cWord;
	Color cColor;
	Font cFont;
	ImageIcon cImageIcon = null;
	
	public ChatMsg(String cNick, String cWord, Color cColor, Font cFont, ImageIcon cImageIcon)
	{
		this.cNick = cNick;
		this.cWord = cWord;
		this.cColor = cColor;
		this.cFont = cFont;
		this.cImageIcon = cImageIcon;
	}
		
	public ChatMsg(String cNick, String cWord, Color cColor, Font cFont)
	{
		this.cNick = cNick;
		this.cWord = cWord;
		this.cColor = cColor;
		this.cFont = cFont;
	}
		
	public ChatMsg(String cNick, String cWord, Color cColor)
	{
		this.cNick = cNick;
		this.cWord = cWord;
		this.cColor = cColor;
	}
		
	public ChatMsg(String cNick, String cWord)
	{
		this.cNick = cNick;
		this.cWord = cWord;
	}
		
	public ChatMsg(String cNick)
	{
		this.cNick = cNick;
	}

	public ChatMsg()
	{
	}
		
	String getNick()
	{
		return cNick;
	}
	
	String getWord()
	{
		return cWord;
	}
	
	Font getFont()
	{
		return cFont;
	}
	
	Color getColor()
	{
		return cColor;
	}
	
	ImageIcon getImageIcon()
	{
		return cImageIcon;
	}

	void setNick(String cNick)
	{
		this.cNick = cNick;
	}
	
	void setWord(String cWord)
	{
		this.cWord = cWord;
	}
	
	void setFont(Font cFont)
	{
		this.cFont = cFont;
	}
	
	void setColor(Color cColor)
	{
		this.cColor = cColor;
	}
	
	void setImageIcon(ImageIcon cImageIcon)
	{
		this.cImageIcon = cImageIcon;
	}
}

