//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
//package database;
import java.util.*;

/*	client Table schima
       (
       	nick 	VARCHAR2(20),
        name 	VARCHAR2(20),
        id 		VARCHAR2(40),
        email	VARCHAR2(40),
        age		VARCHAR2(3),
        sex		VARCHAR2(1),
--		CONSTRAINT	client_nick_uk UNIQUE(nick),
		CONSTRAINT	client_nick_pk primary key(nick)
--		CONSTRAINT	client_id_uk primary key(id)
       );
*/

class ClientPersistent extends Persistent 
{
	PersistentPeer persistentPeer;
	//   String id;
/*	String clientInfo[] = new String[6];

	String nick = clientInfo[0]= null;
	String name = clientInfo[1]= null;
	String id = clientInfo[2]= null;
	String email = clientInfo[3]= null;
	String age = clientInfo[4]= null;
	String sex = clientInfo[5]= null;
*/	
	String nick;
	String name;
	String id;
	String email;
	String age;
	String sex;
	
	String COMMA = ",";
	String START = "(";
	String END = ")";

	String AND = " and ";
	String OR = " or ";
	String EQUAL = " = ";
	
	String query;
	String insertSql;
	String deleteSql;
	String updateSql;
	
	public ClientPersistent(String nick, String name,String id,String email,String age,String sex) 
	{
		this.nick = nick;
		this.name = name;
		this.id = id;
		this.email = email;
		this.age = age;
		this.sex = sex;
		insertSql = "insert into client(nick,name,id,email,age,sex) values" + START + makeStr(nick) + COMMA + makeStr(name)+COMMA + makeStr(id) + COMMA + makeStr(email) + COMMA + makeStr(age) + COMMA + makeStr(sex) + END;
		setQuery("nick",nick, "id", id);
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	public ClientPersistent(String nick)
	{
		setQuery("nick",nick);
		deleteSql = "delete from client where nick = " + makeStr(nick) ; 
		persistentPeer = new ConcreteDatabasePeer(this);
	}
	
  
/*
	void setPersistentPeer(PersistentPeer concreteDatabasePeer)
	{
		this.persistentPeer = concreteDatabasePeer;
	}
*/	
	void setQuery(String columnName,  String condition) 
	{
		query = "select nick,name,id,email,age,sex FROM client WHERE " + columnName + EQUAL + makeStr(condition); 
		System.out.println("setQuery() : "+query);
	}

	void setQuery(String columnName1,  String condition1, String columnName2,  String condition2) 
	{
		query = "select nick,name,id,email,age,sex FROM client WHERE " + columnName1 + EQUAL + makeStr(condition1) + OR + columnName2 + EQUAL + makeStr(condition2) ; 
		System.out.println("setQuery() : "+query);
	}

	PersistentPeer getPersistentPeer()
	{
		return persistentPeer;/////////////////
	}
	String getInsertSql()
	{
		return h2e(insertSql);
	}
	String getDeleteSql()
	{
		return h2e(deleteSql);
	}
	String getUpdateSql()
	{
		return h2e(updateSql);
	}
	String getSelectSql()
	{
		return h2e(query);
	}
////////////////////// Test  ʿ	
	boolean struct(Vector tableV)
	{
		if(tableV.size() > 0)
		{
			String[] column = (String[])(tableV.elementAt(0));
			nick = (column[0]);
			name = (column[1]);
			id = (column[2]);
			email = (column[3]);
			age = (column[4]);
			sex = (column[5]);
			print();
			return true;
		}
		else
		{
			return false;
		}
	}
	
	Vector reStruct(Vector tableV) // ʿ ׸   
	{
		Vector newTableV = new Vector(0,1);
		String[] newColumn;
		String column[];
		for( int i = 0 ; i < tableV.size() ; i++ )
		{
			System.out.println( "reStruct() : "  + i );
			column = (String[])(tableV.elementAt(i));
			newColumn = new String[6];
			newColumn[0] = (column[0]);
			newColumn[1] = (column[1]);
			newColumn[2] = (column[2]);
			newColumn[3] = (column[3]);
			newColumn[4] = (column[4]);
			newColumn[5] = (column[5]);
			newTableV.addElement(newColumn);
		}
		return newTableV;
	}
		
///////////////////////////////////////////////	
	void print(int no)
	{
		System.out.println( "\n\n**********clientpersistent : " + no + "******\n" );
		System.out.print( "nick : " + nick );
		System.out.print( "  |   ");
		System.out.print( "name : " + name );
		System.out.print( "  |   ");
		System.out.print( "id : " + id );
		System.out.print( "  |   ");
		System.out.print( "email : " + email );
		System.out.print( "  |   ");
		System.out.print( "age : " + age );
		System.out.print( "  |   ");
		System.out.print( "sex : " + sex );
		System.out.println( "\n************************************************************\n\n" );
	}

	void print()
	{
		print(0);
	}
	
	
	String makeStr(String str)
	{
		return "\'" + str + "\'";
	}
/*	
	void setColumn(String[] column)
	{
		for ( int no = 0 ; no < column.length ; no ++ )
		{
			clientInfo[no] = column[no];
		}
	}
*/
	String getNick()
	{
		return nick;
	}
	
	String getName()
	{
		return name;
	}
	String getId()
	{
		return id;
	}

	String getEmail()
	{
		return email;
	}
	String getAge()
	{
		return age;
	}
	String getSex()
	{
		return sex;
	}

} /* end class ConcretePersistent */
