//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
//package database;
import java.util.*;
import java.sql.*;
import java.io.*;

abstract class DatabasePeer implements PersistentPeer 
{
  Connection con = null;
  ResultSet rs = null;
  ResultSetMetaData md = null;
  Statement stmt = null;
  
  public boolean insert() 
  {
  	int no = 0;
  	try
  	{
		con = DBConnectionManager.getInstance().getConnection("msgrdb");/////
	    stmt = con.createStatement();
	    no = stmt.executeUpdate(getInsertSql());
	  }
	  catch(SQLException sqlE)
	  {
	  	sqlE.printStackTrace();
	  }
	  finally 
	  {
      try 
      {
        if (stmt != null)   stmt.close();
        if (rs != null)     rs.close();
	    } 
	    catch(SQLException sqlE) 
	    {
		  	sqlE.printStackTrace();
	    }
	    DBConnectionManager.getInstance().freeConnection("msgrdb", con);/////
	  }
	  return( no > 0 ? true : false ); 
	}
	
  public boolean delete() 
  {
  	int no = 0;
  	try
  	{
			con = DBConnectionManager.getInstance().getConnection("msgrdb");/////
	    stmt = con.createStatement();
	    no = stmt.executeUpdate(getDeleteSql());
	  }
	  catch(SQLException sqlE)
	  {
	  	sqlE.printStackTrace();
	  }
	  finally 
	  {
      try 
      {
        if (stmt != null)   stmt.close();
        if (rs != null)     rs.close();
	    } 
	    catch(SQLException sqlE) 
	    {
		  	sqlE.printStackTrace();
	    }
	    DBConnectionManager.getInstance().freeConnection("msgrdb", con);/////
	  }
 	  return( no > 0 ? true : false ); 
	}

  public boolean update() 
  {
  	int no = 0;
  	try
  	{
			con = DBConnectionManager.getInstance().getConnection("msgrdb");/////
	    stmt = con.createStatement();
	    no = stmt.executeUpdate(getUpdateSql());
	  }
	  catch(SQLException sqlE)
	  {
	  	sqlE.printStackTrace();
	  }
	  finally 
	  {
      try 
      {
        if (stmt != null)   stmt.close();
        if (rs != null)     rs.close();
	    } 
	    catch(SQLException sqlE) 
	    {
		  	sqlE.printStackTrace();
	    }
	    DBConnectionManager.getInstance().freeConnection("msgrdb", con);/////
	  }
	  return( no > 0 ? true : false ); 
  }

	public Vector query() 
	{
		Vector tableV = new Vector();
	  	try
	  	{
			con = DBConnectionManager.getInstance().getConnection("msgrdb");/////
			stmt = con.createStatement();
			System.out.println(getSelectSql());
			rs = stmt.executeQuery(getSelectSql());
			md = rs.getMetaData();
			int columnCount = md.getColumnCount();
			String[] row ;
			while (rs.next()) 
			{
				row = new String[columnCount];
				for (int i = 0; i < columnCount; i++) 
				{
				  	row[i] = rs.getString(i+1);
				}
				tableV.addElement(row);

					System.out.println( "\n*******Database Peer*************" );
				for(int no = 0 ; no < row.length ; no ++)
				{
					System.out.print( "row[] : " + row[no] + "    |    " );
				}
					System.out.println( "\n*********************************\n");

			}
		}
		catch(SQLException sqlE)
		{
			sqlE.printStackTrace();
		}
		finally 
		{
			try 
			{
				if (stmt != null)   stmt.close();
				if (rs != null)     rs.close();
			} 
			catch(SQLException sqlE) 
			{
			  	sqlE.printStackTrace();
			}
			DBConnectionManager.getInstance().freeConnection("msgrdb", con);/////
		}
		return tableV;
	}

	abstract String getInsertSql();
	
	abstract String getDeleteSql();
	
	abstract String getUpdateSql(); 
	
	abstract String getSelectSql(); 
} /* end class DatabasePeer */
