import java.util.*;
import java.io.Serializable;

class Datum implements Serializable
{
	int status;
	Object info ;

	static final int TRANS_START 		= 1110;
	static final int TRANS_STOP 		= 1120;

	static final int FILE_TRANSFER		= 1200;
	static final int FILE_INFO 			= 1210;
	static final int FILE_ERROR 		= 1220;
	static final int FILE_LOCK 			= 1230;
	static final int FILE_REQUEST 		= 1240;
	static final int FILE_DENY 			= 1250;

	static final int FILE_NAME 			= 1310;
	static final int FILE_SIZE 			= 1320;

	static final int CHAT_START 		= 1400;
	static final int CHAT_ONGOING 		= 1400;
	static final int CHAT_CLOSE			= 1410;
	static final int CHAT_BUDDY_EXPEL 	= 1440;
	static final int CHAT_NAME_CHANGE 	= 1450;
	static final int CHAT_NEW_BUDDY		= 1460;
	static final int CHAT_ROOM_CLOSE	= 1480;
	static final int CHAT_SOCKET_ERROR	= 1490;

	static final int NICK_NAME			= 1500;
	
	static final int CHAT_ROOM_OPEN		= 1610;
	static final int TITLE_CHANGE_REQUEST 	= 1620;
	static final int ROOM_TITLE_CHANGE 	= 1630;
	static final int CHAT_ROOM_CHANGE 	= 1640;
	

	static final int INVITE_BUDDY  			= 1700;
	static final int INVITE_SEND		 	= 1710;
	static final int INVITE_CONFIRM			= 1720;
	static final int INVITE_ACCEPT 			= 1730;
	static final int INVITE_INFO			= 1740;
	static final int INVITE_GUIDE			= 1750;
	static final int INVITE_ENTRY			= 1760;
	static final int CHAT_MEMO				= 1800;
	
	static final int BUDDY_STATUS			= 1900;
	
	
//	static final int CHAT_INVITE_DELIVERY 	= 1560;
	
//	static final int CHAT_BUDDY_ERROR	= 1500;



	public Datum(int status, Object info)
	{
		this.status = status;
		this.info = info;
	}
	
	int getStatus()
	{
		return status;
	}
	
	Object getInfo()
	{
		return info;
	}
	
	void setStatus(int status)
	{
		this.status = status;
	}
	
	void setInfo(Object info)
	{
		this.info = info;
	}
	void print()
	{
		System.out.println(" status : " + status + "       " + " info : " + info);
	}	
}

