// FILE: c:/temp/SMCHATTING/RoomManagerV.java
// 2001.8.6
// Rev : org
//package SMCHATTING;
import java.util.*;
import java.io.*;
import java.net.*;


public class RoomManagerV extends Vector
{
    static private RoomManagerV instance = (RoomManagerV)null;       
    // Singleton & Double-Checked Locking
    static public RoomManagerV getRoomManagerV() 
    {
        if (instance == null) 
        {
            synchronized(RoomManagerV.class) 
            {
                if (instance == null) 
                {
                    instance = new RoomManagerV();
                    instance.madeFront();
                }
            }
        }
        return instance;
    }

	
	void madeFront()
	{
		RoomV roomV = new RoomV("system","waiting",true,1000);
		addElement(roomV);	
	}


	RoomV moveToFront(RoomMate me)
	{
		((RoomV)elementAt(0)).addRoomMate(me);
			return (RoomV)elementAt(0);
	}

    RoomV addRoomV(String title)
    {
   		RoomV roomV ;
       	for (int i = 0 ; i< size() ; i++)
    	{
    		roomV = (RoomV)elementAt(i);
    		roomV.print();
    		if ( roomV != null && roomV.getTitle() .equals(title) )
    		{
    			return roomV;
	    	}
    	}
		roomV = new RoomV(0,title);
    	addElement(roomV);
    	return roomV;
    }

    RoomV getRoomV(String title)
    {
    	if (size()>0)
    	{
	    	for (int i = 0 ; i< size() ; i++)
	    	{
	    		RoomV roomV = (RoomV)elementAt(i);
	    		if (roomV.getTitle().equals(title))
	    		{
	    			return roomV;
	    		}
	    	}
	    }
    	return null;
    }

	void removeRoomV(String host, String title)
	{
		for ( int i = 0 ; i < size() ; i ++)
		{
			if(((RoomV)elementAt(i)).getTitle().equals(title))
			{
				removeElementAt(i);
				break;
			}
		}
	}
	
	static int MSG_NO;
	String className =" RoomManagerV   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}	
	
} /* end class RoomManagerV */
