// FILE: c:/temp/SMCHATTING/ClientChannelV.java
// 2001.8.6
// Rev : org
//package SMCHATTING;
import java.util.Vector;
import java.io.*;
import java.net.*;


public class RoomV extends Vector
{
	String host;
	String title;
	boolean isOpened;
	int maxNo;
	public RoomV(String host,String title, boolean isOpened, int maxNo)
	{
		this.host = host;
		this.title = title;
		this.isOpened = isOpened; 
		this.maxNo = maxNo;
	}
	
	public RoomV(String host,String title)
	{
		this(host,title,true,100);
	}
	
	public RoomV(int host ,String title)
	{
		this("",title,true,10);
	}
	
	public RoomV(String host,int title)
	{
		this(host,host,false,100);
	}

	public RoomV()
	{
		this("system","waiting",true,1000);
	}
	
	void addRoomMate(RoomMate roomMate)
	{
		addElement(roomMate);
	}
	
	void removeRoomMate(String nick)
	{
		if (size() > 0 )
		{
			for (int i = 0 ; i < size() ; i++ )
			{
				RoomMate roomMate = (RoomMate)elementAt(i);
				if(roomMate.getNick().equals(nick))
				{
					removeElementAt(i);
				}
				break;
			}
		}
	}

    void setHost(String host)
    {
    	this.host = host;
    }
    
    void setTitle(String title)
    {
    	this.title = title;
    }
				
	void setIsOpened(boolean isOpened)
	{
		this.isOpened = isOpened;
	}
	
	void setMaxNo(int maxNo)
	{
		this.maxNo = maxNo;
	}
			
    String getHost()
    {
    	return host;
    }
    
    String getTitle()
    {
    	return title;
    }

	boolean getIsOpened()
	{
		return isOpened;
	}
	
	int getMaxNo()
	{
		return maxNo;
	}
	void print()
	{
		System.out.println("host : " + host + "    |   " + "title : " + title + "   |   " + "maxNo : " + maxNo);
	}

	static int MSG_NO;
	String className =" ServerThread   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}	
}
