import java.net.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import java.lang.Thread;


class SMFileServer 
{
	Socket socket2Client;
	ServerSocket serverSideSocket;
	public SMFileServer(int port, int queLength)
	{
		try//  ´.
		{
			serverSideSocket = new ServerSocket(port,queLength);
			System.out.println("\n\n\n\n File Server is running...");
			serviceStart();
		}
		catch(IOException ioE)
		{
			ioE.printStackTrace();
		}
	}
/*	
	public static void main(String args[])
	{
		final int PORT = 9999; // Ʈ 9999  
		int queLength = 3; // ť  3  
		SMFileServer smFileServer = new SMFileServer(PORT, queLength);
		smFileServer.serviceStart();
	}
*/	
	void serviceStart()
	{
		while(true)
		{
			try //   Ʈ   Ѵ.
			{
				msg("waiting client connet...");
				socket2Client = serverSideSocket.accept();
// 				巹 ó
				msg(" OK !  client conneting .....");
				FileReceiverThread fileReceiverThread = new FileReceiverThread(socket2Client);
				Thread t = new Thread(fileReceiverThread);
				t.start();
				System.out.println("New Thread assigned");

			}
			catch(IOException ioE)
			{
				System.out.println("IO Excption occured !");
				ioE.printStackTrace();
				break;
			}
			catch(SecurityException sE)
			{
				System.out.println("Security Excption occured !");
				sE.printStackTrace();				
				break;
			}
			catch(Exception e)
			{
				System.out.println("Excption occured !");
				e.printStackTrace();				
				break;
			}
			System.out.println("System halted...");			
		}
	}

	static int MSG_NO;
	String className =" FileReceiveThread   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}		
	
}

/*

	
	void init()
	{
		while(true)
		{
			try //   Ʈ   Ѵ.
			{
				socket2Client = serverSideSocket.accept();
				makePipe(); // Ʈ .
				sendInfo(Datum.FILE_NAME,"");		// ȭ̸   û	
				receiveInfo(); // ȭ ̸ ´.
			System.out.println("Thread completed");
			}
			catch(IOException ioE)
			{
				System.out.println("IO Excption occured !");
				ioE.printStackTrace();
			}
			catch(SecurityException sE)
			{
				System.out.println("Security Excption occured !");
				sE.printStackTrace();				
			}
			catch(Exception e)
			{
				System.out.println("Excption occured !");
				e.printStackTrace();				
			}
		}
	}

*/





class FileReceiverThread implements Runnable, FileTransListener
{
	Datum datum = (Datum)null;
	int status ;
	Object info;
//	final static int BUFF_SIZE = 1024;
	final int BUFF_SIZE = 1024;
	byte[] data ; // channel	
	Socket socket2Client;
	ObjectInputStream ois;// Ŭ̾Ʈ   ޱ Ͽ 
	ObjectOutputStream oos; // Ŭ̾Ʈ   Ͽ
	InputStreamReader ir;
	InputStream is;
//	BufferedReader br;
	OutputStream os;
	BufferedOutputStream bo;// ȭ Ͽ 
	String fileName;
	File savingFile;
	long fileSize;
	int receiveCount;
	FileSavingDialog fileSavingDialog;

	public FileReceiverThread(Socket socket2Client)
	{
		this.socket2Client = socket2Client;
	}
	
	public void run()
	{
		try //   Ʈ   Ѵ.
		{
			makePipe(); // Ʈ .
			sendInfo(Datum.FILE_NAME,"");		// ȭ̸   û	
			receiveInfo(); // ȭ ̸ ´.
			System.out.println("Thread completed");
		}
		catch(Exception e)
		{
			System.out.println("Excption occured !");
			e.printStackTrace();				
		}
	}

	public void fileClose() throws Exception
	{
		oos.close();
		os.close();
		bo.close();
		ois.close();
		is.close();
		socket2Client.close();
	}
	
	public void receiveAbort() throws Exception
	{
		sendInfo(Datum.FILE_DENY,""); // ȭ  .
		fileClose();
	}
	
	
	public void fileTransfer(File savingFile) throws Exception  // Thread ó ʿ
	{
		this.savingFile = savingFile;
		msg("savingFile",savingFile);
		sendInfo(Datum.TRANS_START,""); //   㰡 
		msg("readData1");
		readData();
		msg("readData2");
		sendInfo(Datum.FILE_SIZE,""); // ȭ ũ  û.
		msg("sendInfo(Datum.FILE_SIZE)");
		receiveInfo(); // ȭ ũ⸦ ˾ƿ´.
		msg("fileTransfer-receiveInfo()");
		fileClose();
	}
	

	void sendInfo(int protocol, Object str) throws Exception
	{//  ûѴ.
		msg("sendInfo", protocol);
		datum = new Datum(protocol,str);
		datum.print();
		oos.writeObject(datum); // û  .
	}
	
	void receiveInfo() throws Exception
	{// û óѴ.
		datum = (Datum)(ois.readObject());
		datum.print();
		int status = datum.getStatus();
	    switch (status) 
	    {
			case Datum.FILE_NAME: //  ȭ̸  - ȭ    ߰  ʿ 
			{
				fileName = (String)(datum.getInfo()); 
				fileSavingDialog = new FileSavingDialog(fileName,this); /////////////////////////////////
				break;
			}
//			case Datum.TRANS_STOP:  sendInfo(Datum.TRANS_STOP,""); break;
//			case Datum.FILE_ERROR:  sendInfo(Datum.FILE_REQUEST); break;
			case Datum.FILE_SIZE:  //  ȭ ũΰ
			{
				fileSize = Integer.parseInt((String)(datum.getInfo())); 
				System.out.println("fileSize 1 :  " + fileSize);
				if(receiveCount==fileSize)
				{
					sendInfo(Datum.TRANS_STOP,"");
					msg("Datum.TRANS_STOP was sent to client");
				}
//			巹带  ƾ ʿ! 	
				break;
			}
		}
	}

	void makePipe() throws IOException
	{
		is = socket2Client.getInputStream();
		ois = new ObjectInputStream(is);
		os = socket2Client.getOutputStream();
		oos = new ObjectOutputStream(os);
	}
	
	void writeDatum(int status, Object info) throws IOException
	{
		datum = new Datum(status,info);
		oos.writeObject(datum);
	}

	void readData() throws Exception
	{
		FileOutputStream fo = new FileOutputStream(savingFile);
		bo = new BufferedOutputStream(fo);
		receiveCount = 0;
		int count=0;
		do
		{
			data = new byte[BUFF_SIZE];
			count = is.read(data);	
			if (count == -1 )
			{
				break;
			}
			receiveCount += count;
//*************************************************************			
			bo.write(data,0,count);
			try
			{
				Thread.currentThread().sleep(1000);
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
//*************************************************************
		}
		while(count == BUFF_SIZE);
		System.out.print("End of file transfer : readData()");
		
	}

	static int MSG_NO;
	String className =" FileReceiveThread   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}		
}
