/*	 ü    յ    α׷

*/

import java.awt.*;
import java.net.*;
import java.io.*;
import java.lang.Thread;
import java.lang.Runnable;

class ServerRoomTester 
{
	OutputStream os;// ȭ   ¸  
	InputStream is;// ȭ  ޱ 
	ObjectInputStream ois;// ȭ    ޱ 
	ObjectOutputStream oos;//ȭ Ż¸  
	Socket toServer;
	Socket fromServer;
	String serverURL = "127.0.0.1";
	int PORT = 7777;
	Datum datum;
	String title;
	String nick;
	String to;
	
	public static void main(String args[]) 
	{
		ServerRoomTester serverRoomTester = new ServerRoomTester();
		serverRoomTester.testStart(args[0],args[1]);
		System.exit(0);	
	}
	
	void testStart(String nick,String title)
	{		
		this.nick = nick;
		this.title = title ;
		try 
		{
			// Open a connection to args[0]
			toServer = new Socket(serverURL, PORT);
			os = toServer.getOutputStream();
			is = toServer.getInputStream();
			oos = new ObjectOutputStream(os);
			ois = new ObjectInputStream(is);
//			RoomMate roomMate = new RoomMate(nick,ois,oos);
			TesterThread testThread = new TesterThread(ois,nick);
			Thread t = new Thread(testThread);
			t.start();


			// Send the file name to the Server
			sendMessage ();
			
			// Output the file or the result of the request
			// When the EOF is reached, close the connection and exit
			os.close();
			is.close();
			oos.close();
			ois.close();
			toServer.close();
		} 
		catch (Exception e) 
		{
			System.out.println("Connection failed");
			return;
		}
	} // serviceStart
	

	public void sendMessage() throws Exception 
	{
		datum = new Datum (Datum.NICK_NAME,nick) ;
		oos.writeObject (datum);
		datum = new Datum (Datum.CHAT_ROOM_OPEN,title) ;
		oos.writeObject (datum);

		for (int no = 0 ; no < 10 ; no ++)
		{
			datum = new Datum (Datum.CHAT_ONGOING,  " from  :  " + nick + " - " + String.valueOf(no) ) ;
			oos.writeObject (datum);
			Thread.currentThread().sleep(2000);
		}
			datum = new Datum (Datum.CHAT_CLOSE, " End of Chatting Good bye .... " + Thread.currentThread().getName()) ;
			oos.writeObject (datum);
			return;
	} // sendMessage

	static int MSG_NO;
	String className =" ServerRoomTester   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}	

}

class TesterThread implements Runnable
{
	ObjectInputStream ois;
	Datum datum;
	String nick;

	public TesterThread(ObjectInputStream ois,String nick)
	{
		this.ois = ois ;
		this.nick = nick;
	}
	
	public void run()
	{
		while(true)
		{
			try
			{
				System.out.println("----------------- From : " + nick + "------------");
				datum = (Datum)(ois.readObject());
				String chatMsg = (String)datum.getInfo();
				System.out.println(" --> " + chatMsg);
				Thread.currentThread().sleep(1500);
			}
			catch(Exception e)
			{
				break;
			}
		}
	}
	static int MSG_NO;
	String className =" TesterThread   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}	
	
}  // end of class
