// FILE: c:/temp/SMCHATTING/ServerThread.java

//package SMCHATTING;
import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.Thread;
import java.lang.Runnable;


class ServerThread implements Runnable
{
	RoomV roomV;
	Server chatServer;
	String clientAddress;
	Socket socket2Client;
	ObjectInputStream ois;
	ObjectOutputStream oos;
	boolean EXIT = false;
	Datum datum;
	Object info;
	String title = null;
	String nick = null;
	String deadNick;
	String inviteBuddy;
	ChatMsg chatMsg;
	String CHATSERVER = "ü ý";
	int PAUSE_TIME = 500;
	int ERROR_COUNT = 0 ;
	int error_count = 0 ;
	RoomMate roomMate,me;
	
	public ServerThread(Server chatServer, Socket socket2Client) throws IOException
	{
		this.chatServer = chatServer;
		this.socket2Client = socket2Client;
		clientAddress = socket2Client.getInetAddress().getHostAddress();
//		this.nick = nick;
		ois = new ObjectInputStream(socket2Client.getInputStream());
		oos = new ObjectOutputStream(socket2Client.getOutputStream());
	}
	
	public void run()
	{
		while(!EXIT)
		{
			try
			{
				datum = (Datum)ois.readObject();
				int status = datum.getStatus();
				info = datum.getInfo();
				actionSwitch(status);////////
				Thread.currentThread().sleep(PAUSE_TIME);
			}
			catch(Exception e)
			{
//				actionSwitch(Datum.CHAT_SOCKET_ERROR);
				EXIT = true;
			}
		}
		
	}		// Ϳ  actionSwitch  socket error  ó
	
	void actionSwitch(int status) 
	{
		try
		{
			switch(status)
			{
				case Datum.CHAT_NEW_BUDDY :
					broadCast(datum);
					break;

				case Datum.NICK_NAME :
					this.nick = (String)info;
			    	me = new RoomMate(nick, clientAddress, ois, oos);// ü 
			    	
			    	ClientChannelT.getClientChannelT().addClientChannel(nick,me);
			    	System.out.println(nick + "   ü Ͽϴ.");
//˻	    	RoomMate returnRoomMate = ClientChannelT.getClientChannelT().getClientChannel(nick);
//			    	System.out.println(nick + " ̸ ϵ  :  " + returnRoomMate);
			    	RoomManagerV.getRoomManagerV().moveToFront(me);
			    	System.out.println("waiting  Ͽϴ.");
					break;

				case Datum.CHAT_ROOM_OPEN :
					String title = (String)info;
					movingRoom(title);
					
					break;
					
				case Datum.CHAT_ONGOING :
					System.out.println("broadcast ");
					broadCast(datum);
					System.out.println("broadcast ");
					break;
					
				case Datum.CHAT_CLOSE :
//					if(((String)info).equals(nick))
					{
						roomV.removeRoomMate(nick);
				    	ClientChannelT.getClientChannelT().removeClientChannel(nick);
						EXIT = true ;
					}
					break;
				
				case Datum.CHAT_NAME_CHANGE :
					broadCast(datum);
					break;
									
				case Datum.CHAT_BUDDY_EXPEL :
					if(nick == roomV.getHost() )
					{
						buddyExpel((String)info);
						broadCast(datum);
					}
					break;
										
				case Datum.TITLE_CHANGE_REQUEST :
					broadCast(datum);
					break;
							
				case Datum.ROOM_TITLE_CHANGE :
					roomV.setTitle((String)info);
					broadCast(datum);
					break;
							
				case Datum.CHAT_ROOM_CLOSE :
					if( ((String)info).equals(roomV.getHost()) )
					{
						roomV = RoomManagerV.getRoomManagerV().moveToFront(me);
					}
					break;
	
				case Datum.CHAT_SOCKET_ERROR :
					roomV.removeRoomMate(nick);
			    	ClientChannelT.getClientChannelT().removeClientChannel(nick);
					EXIT = true ;
//					chatServer.destroyThread(Thread.currentThread());
					break;
					
				case Datum.INVITE_BUDDY :
					inviteBuddy = (String)info;
					System.out.println(" ʴƾ Ͽϴ.");
					send2OutputChannel(inviteBuddy,Datum.INVITE_SEND, nick);
					System.out.println(" ʴ ߼Ͽϴ.");
					break;
					
				case Datum.INVITE_ACCEPT:
					inviteBuddy = (String)info;
					System.out.println(inviteBuddy + "  ʴ뿡 Ⲩ ϰڴٴ Դϴ.");
					send2OutputChannel(inviteBuddy,Datum.INVITE_ACCEPT,nick);
					break;
					
				case Datum.INVITE_INFO:
					inviteBuddy = (String)info;
					System.out.println((String)info + "   û ϴ.");
					send2OutputChannel(inviteBuddy,Datum.INVITE_INFO,roomV.getTitle());
					break;
					
				case Datum.INVITE_GUIDE:
					System.out.println(" ο  Ͽϴ.");
					title = (String)info;
					roomV.removeRoomMate(nick);
					System.out.println("  ϴ ̸ : " + roomV.getTitle());
					roomV = RoomManagerV.getRoomManagerV().getRoomV(title);
					System.out.println("   ̸ : " + roomV.getTitle());
					roomV.addRoomMate(me);
					System.out.println("   Ͽϴ. : " + me.getNick());
					System.out.println("   ٲپϴ.");
					break;

				case Datum.CHAT_MEMO :
					ChatMsg chatMsg  = (ChatMsg)info;
					String toBuddy = (String)(chatMsg.getNick());
					chatMsg.setNick(nick);
					System.out.println("  Ͽϴ.");
					send2OutputChannel(toBuddy,Datum.CHAT_MEMO,chatMsg);
					System.out.println("  ߼Ͽϴ.");
					break;

				case Datum.FILE_TRANSFER :
					String fileBuddy = (String)info;
					System.out.println("  Ͽϴ.");
					String clientAddress = ClientChannelT.getClientChannelT().getClientChannel(fileBuddy).getClientAddress();
					System.out.println(" clientAddress : " + clientAddress);
					datum = new Datum(Datum.FILE_TRANSFER,clientAddress);
					System.out.println("   ȮϿϴ.");
					oos.writeObject(datum);
					break;

				case Datum.BUDDY_STATUS :
					Vector buddyMemoV = (Vector)info;
					System.out.println(" buddy  Ͽϴ.");
					Vector buddyStatusV = buddyStatus(buddyMemoV);
					datum = new Datum(Datum.BUDDY_STATUS,buddyStatusV);
					System.out.println("   ȮϿϴ.");
					oos.writeObject(datum);
					break;

			}
		}
		catch(Exception e2)
		{
			e2.printStackTrace();
		}
	}
	
	boolean isBuddyInvite(String inviteBuddy)
	{
		return true;//  ִ   ִ ?
	}
	
	void buddyExpel(String expelBuddy)
	{
	}
	
	public void onlineService() // For future implementation
	{
	}
/*	
	void broadCast(Object datum) 
	{
		Enumeration numeration = roomV.elements();
		while ( numeration.hasMoreElements())
		{
			roomMate =(RoomMate)numeration.nextElement();
			try
			{
				roomMate.print();
				System.out.println(" roomMate ̸ : " + roomMate.getNick());
				roomMate.getObjectOutputStream().writeObject(datum);
			}
			catch(IOException ioE)
			{
				String deadNick = roomMate.getNick();
				if (deadNick == nick)
				{
					error_count ++;
					if ( error_count > ERROR_COUNT )
					{
						actionSwitch(Datum.CHAT_SOCKET_ERROR);
					}
				}
			}
		}
	}
*/
	void broadCast(Object datum) 
	{
		System.out.println(" 濡 ִ   : " + roomV.size());
		for(int i = 0; i < roomV.size() ; i++)
		{
			roomMate =(RoomMate)roomV.elementAt(i);
			try
			{
				roomMate.print();
				System.out.println(" roomMate ̸ : " + roomMate.getNick());
				roomMate.getObjectOutputStream().writeObject(datum);
			}
			catch(IOException ioE)
			{
				String deadNick = roomMate.getNick();
				if (deadNick == nick)
				{
					error_count ++;
					if ( error_count > ERROR_COUNT )
					{
						actionSwitch(Datum.CHAT_SOCKET_ERROR);
					}
				}
			}
		}
	}


	public void sendInvitation(String from,RoomMate roomMate )
	{
		ObjectInputStream ois = roomMate.getObjectInputStream();
		String invitationMsg = from + "   ʴԴϴ."; 
		Datum datum = new Datum(Datum.INVITE_SEND,invitationMsg);
		try
		{
			System.out.println("sendInvitation : ش Ŭ̾Ʈ  մϴ."); 
			oos.writeObject(datum);
			System.out.println("sendInvitation : ش Ŭ̾Ʈ  ϷϿϴ."); 
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	void send2OutputChannel(String to,int protocol, Object info)
	{	
		System.out.println("send2OutputChannelԴϴ. ޴» : " + to);
		RoomMate roomMate = ClientChannelT.getClientChannelT().getClientChannel(to);
		System.out.println("roomMate  ϴ. : " + to + " -> " + roomMate);
		try
		{
			System.out.println(" Ʈ ϴ."); 
			ObjectOutputStream oos = roomMate.getObjectOutputStream();
			System.out.println(" Ʈ ϴ."); 
			Datum datum = new Datum(protocol,info);
			System.out.println("sendInvitation : send2Client   մϴ."); 
			oos.writeObject(datum);
			System.out.println("sendInvitation : send2Client   ϷϿϴ."); 
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	void send2InputChannel(String to,int protocol, Object info)
	{	
		System.out.println("send2InputChannelԴϴ. ޴» : " + to);
		RoomMate roomMate = ClientChannelT.getClientChannelT().getClientChannel(to);
		System.out.println("roomMate  ϴ. : " + to + " -> " + roomMate);
		try
		{
			ObjectInputStream ois = roomMate.getObjectInputStream();
			System.out.println("Է Ʈ ϴ."); 
			Datum datum = new Datum(protocol,info);
			System.out.println("sendInvitation : send2Client   մϴ."); 
			oos.writeObject(datum);
			System.out.println("sendInvitation : send2Client   ϷϿϴ."); 
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	void movingRoom(String title)
	{
		roomV = RoomManagerV.getRoomManagerV().getRoomV(title);
		if (roomV == null)
		{
			roomV = RoomManagerV.getRoomManagerV().addRoomV(title);
		}
		roomV.addRoomMate(me);
	}
	
	Vector buddyStatus(Vector buddyMemoV)
	{
		p.r(this,"buddyStatus", "*************** Arrived*********");
		String[] buddyMemo ;
		Vector buddyStatusV = new Vector();
		for (int i = 0 ; i < buddyMemoV.size(); i++)
		{
			buddyMemo = (String[])buddyMemoV.elementAt(i);
			if( ClientChannelT.getClientChannelT().getClientChannel(buddyMemo[1])!=null)
			{
				buddyMemo[3] = "1";
			}
			buddyStatusV.addElement(buddyMemo);
				p.r(this,"no of buddy",i);
				p.r(this,"buddy",buddyMemo[1]);
				p.r(this,"Online state",buddyMemo[3]);
		}
		return 	buddyStatusV;
	}
	
	static int MSG_NO;
	String className =" ServerThread   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}	
} /* end class ServerThread */
