// TestApp.java

import java.io.*;
import java.sql.*;

public class TestApp {

    /**
     *
     ************************************************************************************/    
    public static void main(String args[]) {
  
        Connection con = null;

        ResultSet rs = null;
        ResultSetMetaData md = null;
        Statement stmt = null;
        try {
            con = DBManager.getInstance().getConnection("msgrdb");/////
            stmt = con.createStatement();
            String query = "SELECT * FROM client";
            rs = stmt.executeQuery(query);
            md = rs.getMetaData();
            System.out.println(query);
            while (rs.next()) {
                for (int i = 1; i < md.getColumnCount(); i++) {
                    System.out.print(rs.getString(i) + ", ");
                    System.out.println();
                }
            }
            stmt.close();
            rs.close();
        } catch (SQLException e) {
            e.printStackTrace(System.out);
        } finally {
            try {
                if (stmt != null)   stmt.close();
                if (rs != null)     rs.close();
           //     if (md != null)     md.close();
            } catch(SQLException e) {}
            DBManager.getInstance().freeConnection("msgrdb", con);/////
        }
        DBManager.getInstance().release();
    }
} 
