//
// ѽ¹
//2001.9.17
//package exception.util


import java.util.*;
import java.io.*;

public class InitProperty 
{
    static private InitProperty instance;  
	static ResourceBundle resource = null;        
	static String FILE_NAME="init.properties"; 
    static public InitProperty getInstance() 
    {
        if (instance == null) 
        {
            synchronized(InitProperty.class) 
            {
                if (instance == null) 
                {
                    instance = new InitProperty();
                }
            }
        }
        return instance;
    }

    private InitProperty() 
    {
        init();
    }

	public void init() 
	{
		try 
		{
//			resource = ResourceBundle.getBundle("myprop", Locale.KOREA); // ̰  
			resource = ResourceBundle.getBundle("init", Locale.US); // ̰  
		} catch(MissingResourceException e) 
		{
			System.out.println("Resource was not found!!!");
		}
		Enumeration enum = resource.getKeys();
		Object key = null;
		while(enum.hasMoreElements()) 
		{
			key = enum.nextElement();
			System.out.println(key + "\t\t" + p.e2h(resource.getString((String)key)));
		}
	}
	public static String getValue(String name)
	{
		return resource.getString(name);
	}
	public static void setValue(String name, String value)
	{
		Enumeration enum = resource.getKeys();
		Object key = null;
		PrintWriter outWriter = null;
		try
		{
			outWriter = new PrintWriter(new FileOutputStream(FILE_NAME));
		}
		catch(FileNotFoundException fnE)
		{
			fnE.printStackTrace();
		}
		
		while(enum.hasMoreElements()) 
		{
			key = enum.nextElement();
			System.out.println(key + "=" + p.e2h(resource.getString((String)key)));
			outWriter.println(key+"="+p.h2e(resource.getString((String)key)));
			
		}
		outWriter.flush();
		outWriter.close();
	}
}
